#pragma once


// DirectX12֘A
#include <d3d12.h>
#include <dxgi1_6.h>

// ComPtrɎgp
#include <wrl.h>
using Microsoft::WRL::ComPtr;



// DirectX12NX
class DirectX12
{
public:
	DirectX12(void);
	~DirectX12(void);

	// DirectX̏
	bool Initialize(HWND hWnd, int width, int height, bool isFullscreen);
	// DirectX̏I
	void Finalize(void);


	// D3D12DeviceIuWFNg̎擾
	ComPtr<ID3D12Device>& GetDevice(void) { return m_pDevice; }
	ComPtr<ID3D12GraphicsCommandList>& GetCommandList(void) { return m_pCommandList; }
	ComPtr<ID3D12CommandQueue>& GetCommandQueue(void) { return m_pCommandQueue; }

private:
	ComPtr<ID3D12Device> m_pDevice;
	ComPtr<IDXGISwapChain4> m_pSwapChain;
	ComPtr<ID3D12CommandQueue> m_pCommandQueue;
	ComPtr<ID3D12CommandAllocator> m_pCommandAllocator;
	ComPtr<ID3D12GraphicsCommandList> m_pCommandList;
	int m_RtvDescriptorSize;
	UINT m_FrameIndex;
	HANDLE m_FenceEvent;
	ComPtr<ID3D12Fence> m_pFence;
	UINT m_Width;
	UINT m_Height;


	const UINT FrameCount = 2;
};

